"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getSourceDataGroups = getSourceDataGroups;
function sortByInputIndexThenByName(connection1, connection2) {
    if (connection1.inputIndex === connection2.inputIndex) {
        return connection1.from.name.localeCompare(connection2.from.name);
    }
    else {
        return connection1.inputIndex - connection2.inputIndex;
    }
}
function getSourceDataGroups(graph, node, runData, pinnedData) {
    const connections = graph.getConnections({ to: node });
    const sortedConnectionsWithData = [];
    for (const connection of connections) {
        const hasData = runData[connection.from.name] || pinnedData[connection.from.name];
        if (hasData) {
            sortedConnectionsWithData.push(connection);
        }
    }
    sortedConnectionsWithData.sort(sortByInputIndexThenByName);
    const groups = [];
    let currentGroup = [];
    let currentInputIndex = -1;
    while (sortedConnectionsWithData.length > 0) {
        const connectionWithDataIndex = sortedConnectionsWithData.findIndex((c) => c.inputIndex > currentInputIndex);
        const connection = sortedConnectionsWithData[connectionWithDataIndex];
        if (connection === undefined) {
            groups.push(currentGroup);
            currentGroup = [];
            currentInputIndex = -1;
            continue;
        }
        currentInputIndex = connection.inputIndex;
        currentGroup.push(connection);
        if (connectionWithDataIndex >= 0) {
            sortedConnectionsWithData.splice(connectionWithDataIndex, 1);
        }
    }
    groups.push(currentGroup);
    return groups;
}
//# sourceMappingURL=getSourceDataGroups.js.map